﻿init python:
    class locale:
        def __init__(self, name, xy, action, icon = None, locked = False):
            self.name = name
            self.xy = xy
            self.action = action
            self.locked = locked
            self.icon = icon
    class place_class:
        def __init__(self, name, locales = []):
            self.name = name
            self.locales = locales
        def discover(self, what, where = None):
            if where:
                for ii, i in enumerate(self.locales):
                    if i == where:
                        self.locales.insert(what, ii)
                        break
                else:
                    self.locales.append(what)
            else:
                self.locales.append(what)
            msg.msg("Discovered {}".format(what.name))
        def unlock(self, what):
            for i in self.locales:
                if i == what:
                    i.locked = False
                    break

screen place(place):
    modal True
    tag places
    default hov = None

    for i in place.locales:
        button:
            pos i.xy anchor 0.0,0.0
            if i.icon:
                padding 0,0 background None
                add i.icon
            else:
                text i.name
            if not i.locked:
                action Hide("place"), i.action
            at place_transform
            focus_mask True
            hovered SetScreenVariable("hov", i.name)
    vbox:
        align 1.0,0.0 offset -100,100
        if place.name:
            frame:
                text place.name
        if hov:
            text hov


transform place_transform:
    on idle:
        ease .2 additive 0.0
    on hover:
        ease .2 additive 0.5